diff --git a/mod/assign/locallib.php b/mod/assign/locallib.php
index 7566973..9035df3 100644
--- a/mod/assign/locallib.php
+++ b/mod/assign/locallib.php
@@ -4726,6 +4726,7 @@ class assign {
         $eventdata->notification    = 1;
         $eventdata->contexturl      = $info->url;
         $eventdata->contexturlname  = $info->assignment;
+        $eventdata->courseid        = $course->id;
 
         message_send($eventdata);
     }
diff --git a/mod/feedback/lib.php b/mod/feedback/lib.php
index 68ab379..2ff1ce2 100644
--- a/mod/feedback/lib.php
+++ b/mod/feedback/lib.php
@@ -2971,7 +2971,10 @@ function feedback_send_email($cm, $feedback, $course, $userid) {
                 $eventdata->fullmessage      = $posttext;
                 $eventdata->fullmessageformat = FORMAT_PLAIN;
                 $eventdata->fullmessagehtml  = $posthtml;
-                $eventdata->smallmessage     = '';
+                $eventdata->smallmessage     = $postsubject;
+                $eventdata->courseid         = $course->id;
+                $eventdata->contexturl       = $info->url;
+                $eventdata->contexturlname   = $info->feedback;
                 message_send($eventdata);
             } else {
                 $eventdata = new stdClass();
@@ -2983,7 +2986,10 @@ function feedback_send_email($cm, $feedback, $course, $userid) {
                 $eventdata->fullmessage      = $posttext;
                 $eventdata->fullmessageformat = FORMAT_PLAIN;
                 $eventdata->fullmessagehtml  = $posthtml;
-                $eventdata->smallmessage     = '';
+                $eventdata->smallmessage     = $postsubject;
+                $eventdata->courseid         = $course->id;
+                $eventdata->contexturl       = $info->url;
+                $eventdata->contexturlname   = $info->feedback;
                 message_send($eventdata);
             }
         }
@@ -3041,6 +3047,13 @@ function feedback_send_email_anonym($cm, $feedback, $course) {
             $eventdata->fullmessageformat = FORMAT_PLAIN;
             $eventdata->fullmessagehtml  = $posthtml;
             $eventdata->smallmessage     = '';
+            $eventdata->smallmessage     = $postsubject;
+            $eventdata->courseid         = $course->id;
+            $eventdata->contexturl       = $info->url;
+            $eventdata->contexturlname   = $info->feedback;
+             message_send($eventdata);
+         }
+     }
             message_send($eventdata);
         }
     }
diff --git a/mod/feedback/show_nonrespondents.php b/mod/feedback/show_nonrespondents.php
index 1ed0250..ba76e20 100644
--- a/mod/feedback/show_nonrespondents.php
+++ b/mod/feedback/show_nonrespondents.php
@@ -106,7 +106,10 @@ if ($action == 'sendmessage' AND has_capability('moodle/course:bulkmessaging', $
             $eventdata->fullmessage      = html_to_text($htmlmessage);
             $eventdata->fullmessageformat = FORMAT_PLAIN;
             $eventdata->fullmessagehtml  = $htmlmessage;
-            $eventdata->smallmessage     = '';
+            $eventdata->smallmessage     = $subject;
+            $eventdata->courseid         = $course->id;
+            $eventdata->contexturl       = $link3;
+            $eventdata->contexturlname   = $feedback->name;
             $good = $good && message_send($eventdata);
         }
         if (!empty($good)) {
diff --git a/mod/forum/lib.php b/mod/forum/lib.php
index 7e578f3..1cafed0 100644
--- a/mod/forum/lib.php
+++ b/mod/forum/lib.php
@@ -775,6 +775,7 @@ function forum_cron() {
                 $contexturl = new moodle_url('/mod/forum/discuss.php', array('d' => $discussion->id), 'p' . $post->id);
                 $eventdata->contexturl = $contexturl->out();
                 $eventdata->contexturlname = $discussion->name;
+				$eventdata->courseid = $course->id;
 
                 $mailresult = message_send($eventdata);
                 if (!$mailresult) {
diff --git a/mod/lesson/essay.php b/mod/lesson/essay.php
index 3026e20..bf3d352 100644
--- a/mod/lesson/essay.php
+++ b/mod/lesson/essay.php
@@ -231,6 +231,13 @@ switch ($mode) {
                 $a->comment  = s($essayinfo->response);
 
                 // Fetch message HTML and plain text formats
+                
+                $b = new stdClass();
+                $b->essay = format_string($pages[$attempt->pageid]->title,true);
+                $b->lesson = $lesson->properties()->name;
+                $b->course = $course->idnumber? $course->idnumber : $course->fullname;
+                $smallmessage  = get_string('essayemailmessage3', 'lesson', $b);
+
                 $message  = get_string('essayemailmessage2', 'lesson', $a);
                 $plaintext = format_text_email($message, FORMAT_HTML);
 
@@ -245,11 +252,13 @@ switch ($mode) {
                 $eventdata->fullmessage      = $plaintext;
                 $eventdata->fullmessageformat = FORMAT_PLAIN;
                 $eventdata->fullmessagehtml  = $message;
-                $eventdata->smallmessage     = '';
+                $eventdata->smallmessage     = $smallmessage;
+                $eventdata->contexturl       = $CFG->wwwroot . '/grade/report/user/index.php?id=' . $course->id;
 
                 // Required for messaging framework
                 $eventdata->component = 'mod_lesson';
                 $eventdata->name = 'graded_essay';
+                $eventdata->courseid = $course->id;
 
                 message_send($eventdata);
                 $essayinfo->sent = 1;
diff --git a/mod/lesson/lang/en/lesson.php b/mod/lesson/lang/en/lesson.php
index dd9dcf8..a8bcb75 100644
--- a/mod/lesson/lang/en/lesson.php
+++ b/mod/lesson/lang/en/lesson.php
@@ -167,6 +167,7 @@ $string['eolstudentoutoftimenoanswers'] = 'You did not answer any questions.  Yo
 $string['essay'] = 'Essay';
 $string['essayemailmessage'] = '<p>Essay prompt:<blockquote>{$a->question}</blockquote></p><p>Your response:<blockquote><em>{$a->response}</em></blockquote></p><p>{$a->teacher}\'s comments:<blockquote><em>{$a->comment}</em></blockquote></p><p>You have received {$a->earned} out of {$a->outof} for this essay question.</p><p>Your grade for the lesson has been changed to {$a->newgrade}&#37;.</p>';
 $string['essayemailmessage2'] = '<p>Essay prompt:<blockquote>{$a->question}</blockquote></p><p>Your response:<blockquote><em>{$a->response}</em></blockquote></p><p>Grader\'s comments:<blockquote><em>{$a->comment}</em></blockquote></p><p>You have received {$a->earned} out of {$a->outof} for this essay question.</p><p>Your grade for the lesson has been changed to {$a->newgrade}&#37;.</p>';
+$string['essayemailmessage3'] = 'Your submission to {$a->lesson} essay {$a->essay} in {$a->course} has been graded.';
 $string['essayemailsubject'] = 'Your grade for {$a} question';
 $string['essays'] = 'Essays';
 $string['essayscore'] = 'Essay score';
diff --git a/mod/quiz/locallib.php b/mod/quiz/locallib.php
index ce078fa..da0b627 100644
--- a/mod/quiz/locallib.php
+++ b/mod/quiz/locallib.php
@@ -1411,6 +1411,7 @@ function quiz_send_confirmation($recipient, $a) {
     $eventdata->smallmessage      = get_string('emailconfirmsmall', 'quiz', $a);
     $eventdata->contexturl        = $a->quizurl;
     $eventdata->contexturlname    = $a->quizname;
+    $eventdata->courseid          = $a->course->id;
 
     // ... and send it.
     return message_send($eventdata);
@@ -1447,6 +1448,7 @@ function quiz_send_notification($recipient, $submitter, $a) {
     $eventdata->smallmessage      = get_string('emailnotifysmall', 'quiz', $a);
     $eventdata->contexturl        = $a->quizreviewurl;
     $eventdata->contexturlname    = $a->quizname;
+    $eventdata->courseid          = $a->course->id;
 
     // ... and send it.
     return message_send($eventdata);
@@ -1504,6 +1506,7 @@ function quiz_send_notification_messages($course, $quiz, $attempt, $context, $cm
 
     $a = new stdClass();
     // Course info.
+    $a->course          = $course;
     $a->coursename      = $course->fullname;
     $a->courseshortname = $course->shortname;
     // Quiz info.
@@ -1615,6 +1618,7 @@ function quiz_send_overdue_message($course, $quiz, $attempt, $context, $cm) {
     $eventdata->smallmessage      = get_string('emailoverduesmall', 'quiz', $a);
     $eventdata->contexturl        = $a->quizurl;
     $eventdata->contexturlname    = $a->quizname;
+    $eventdata->courseid          = $course->id;
 
     // Send the message.
     return message_send($eventdata);