diff --git a/analytics/classes/local/indicator/community_of_inquiry_activity.php b/analytics/classes/local/indicator/community_of_inquiry_activity.php
index 511e43a..067ca7b 100644
--- a/analytics/classes/local/indicator/community_of_inquiry_activity.php
+++ b/analytics/classes/local/indicator/community_of_inquiry_activity.php
@@ -75,7 +75,7 @@ abstract class community_of_inquiry_activity extends linear {
      *
      * @var string The activity name (e.g. assign or quiz)
      */
-    protected final function get_activity_type() {
+    public final function get_activity_type() {
         $class = get_class($this);
         $package = stristr($class, "\\", true);
         $type = str_replace("mod_", "", $package);
@@ -662,5 +662,5 @@ abstract class community_of_inquiry_activity extends linear {
      *
      * @return string
      */
-    abstract protected function get_indicator_type();
+    abstract public function get_indicator_type();
 }
diff --git a/course/classes/analytics/indicator/potential_cognitive_depth.php b/course/classes/analytics/indicator/potential_cognitive_depth.php
index c2af678..23a5ccc 100644
--- a/course/classes/analytics/indicator/potential_cognitive_depth.php
+++ b/course/classes/analytics/indicator/potential_cognitive_depth.php
@@ -26,6 +26,8 @@ namespace core_course\analytics\indicator;
 
 defined('MOODLE_INTERNAL') || die();
 
+use \core_analytics\local\indicator\community_of_inquiry_activity;
+
 /**
  * Potential cognitive depth indicator.
  *
@@ -75,10 +77,9 @@ class potential_cognitive_depth extends \core_analytics\local\indicator\linear {
 
             $cognitivedepthindicator = $this->get_cognitive_indicator($cminfo->modname);
             $value = $cognitivedepthindicator->get_cognitive_depth_level($cminfo);
-            if ($value > \core_analytics\local\indicator\community_of_inquiry_activity::MAX_COGNITIVE_LEVEL) {
+            if ($value > community_of_inquiry_activity::MAX_COGNITIVE_LEVEL) {
                 throw new \coding_exception('Maximum cognitive depth level is ' .
-                    \core_analytics\local\indicator\community_of_inquiry_activity::MAX_COGNITIVE_LEVEL .
-                    ', ' . $value . ' provided by ' . get_class($this));
+                    community_of_inquiry_activity::MAX_COGNITIVE_LEVEL . ', ' . $value . ' provided by ' . get_class($this));
             }
 
         } else {
@@ -97,10 +98,9 @@ class potential_cognitive_depth extends \core_analytics\local\indicator\linear {
                     continue;
                 }
                 $level = $cognitivedepthindicator->get_cognitive_depth_level($cm);
-                if ($level > \core_analytics\local\indicator\community_of_inquiry_activity::MAX_COGNITIVE_LEVEL) {
+                if ($level > community_of_inquiry_activity::MAX_COGNITIVE_LEVEL) {
                     throw new \coding_exception('Maximum cognitive depth level is ' .
-                        \core_analytics\local\indicator\community_of_inquiry_activity::MAX_COGNITIVE_LEVEL .
-                        ', ' . $value . ' provided by ' . get_class($this));
+                        community_of_inquiry_activity::MAX_COGNITIVE_LEVEL . ', ' . $value . ' provided by ' . get_class($this));
                 }
                 $total += $level;
             }
@@ -121,10 +121,14 @@ class potential_cognitive_depth extends \core_analytics\local\indicator\linear {
      * @return \core_analytics\local\indicator\base|false
      */
     protected function get_cognitive_indicator($modname) {
-        $classname = '\mod_' . $modname . '\analytics\indicator\cognitive_depth';
-        if (!class_exists($classname)) {
-            return false;
+        $indicators = \core_analytics\manager::get_all_indicators();
+        foreach ($indicators as $indicator) {
+            if ($indicator instanceof community_of_inquiry_activity &&
+                    $indicator->get_indicator_type() === community_of_inquiry_activity::INDICATOR_COGNITIVE &&
+                    $indicator->get_activity_type() === $modname) {
+                return $indicator;
+            }
         }
-        return new $classname();
+        return false;
     }
 }
diff --git a/course/classes/analytics/indicator/potential_social_breadth.php b/course/classes/analytics/indicator/potential_social_breadth.php
index 7a7b063..448fe06 100644
--- a/course/classes/analytics/indicator/potential_social_breadth.php
+++ b/course/classes/analytics/indicator/potential_social_breadth.php
@@ -26,6 +26,8 @@ namespace core_course\analytics\indicator;
 
 defined('MOODLE_INTERNAL') || die();
 
+use \core_analytics\local\indicator\community_of_inquiry_activity;
+
 /**
  * Potential social breadth indicator.
  *
@@ -74,7 +76,7 @@ class potential_social_breadth extends \core_analytics\local\indicator\linear {
 
             $socialbreadthindicator = $this->get_social_indicator($cminfo->modname);
             $value = $socialbreadthindicator->get_social_breadth_level($cminfo);
-            if ($value > \core_analytics\local\indicator\community_of_inquiry_activity::MAX_SOCIAL_LEVEL) {
+            if ($value > community_of_inquiry_activity::MAX_SOCIAL_LEVEL) {
                 $this->level_not_accepted($value);
             }
 
@@ -94,7 +96,7 @@ class potential_social_breadth extends \core_analytics\local\indicator\linear {
                     continue;
                 }
                 $level = $socialbreadthindicator->get_social_breadth_level($cm);
-                if ($level > \core_analytics\local\indicator\community_of_inquiry_activity::MAX_SOCIAL_LEVEL) {
+                if ($level > community_of_inquiry_activity::MAX_SOCIAL_LEVEL) {
                     $this->level_not_accepted($level);
                 }
                 $total += $level;
@@ -116,11 +118,15 @@ class potential_social_breadth extends \core_analytics\local\indicator\linear {
      * @return \core_analytics\local\indicator\base|false
      */
     protected function get_social_indicator($modname) {
-        $classname = '\mod_' . $modname . '\analytics\indicator\social_breadth';
-        if (!class_exists($classname)) {
-            return false;
+        $indicators = \core_analytics\manager::get_all_indicators();
+        foreach ($indicators as $indicator) {
+            if ($indicator instanceof community_of_inquiry_activity &&
+                    $indicator->get_indicator_type() === community_of_inquiry_activity::INDICATOR_SOCIAL &&
+                    $indicator->get_activity_type() === $modname) {
+                return $indicator;
+            }
         }
-        return new $classname();
+        return false;
     }
 
     /**
diff --git a/mod/assign/classes/analytics/indicator/cognitive_depth.php b/mod/assign/classes/analytics/indicator/cognitive_depth.php
index 3b0b35d..a963fb9 100644
--- a/mod/assign/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/assign/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/assign/classes/analytics/indicator/social_breadth.php b/mod/assign/classes/analytics/indicator/social_breadth.php
index a905c20..1ccce9b 100644
--- a/mod/assign/classes/analytics/indicator/social_breadth.php
+++ b/mod/assign/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/book/classes/analytics/indicator/cognitive_depth.php b/mod/book/classes/analytics/indicator/cognitive_depth.php
index 3842c80..5a7e473 100644
--- a/mod/book/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/book/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/book/classes/analytics/indicator/social_breadth.php b/mod/book/classes/analytics/indicator/social_breadth.php
index 39d7c6f..2ef7ea0 100644
--- a/mod/book/classes/analytics/indicator/social_breadth.php
+++ b/mod/book/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/chat/classes/analytics/indicator/cognitive_depth.php b/mod/chat/classes/analytics/indicator/cognitive_depth.php
index aa74afd..9e757cf 100644
--- a/mod/chat/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/chat/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/chat/classes/analytics/indicator/social_breadth.php b/mod/chat/classes/analytics/indicator/social_breadth.php
index 186b8f5..532af44 100644
--- a/mod/chat/classes/analytics/indicator/social_breadth.php
+++ b/mod/chat/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/choice/classes/analytics/indicator/cognitive_depth.php b/mod/choice/classes/analytics/indicator/cognitive_depth.php
index 2f8672a..0f1b679 100644
--- a/mod/choice/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/choice/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/choice/classes/analytics/indicator/social_breadth.php b/mod/choice/classes/analytics/indicator/social_breadth.php
index 9509b6a..e97e493 100644
--- a/mod/choice/classes/analytics/indicator/social_breadth.php
+++ b/mod/choice/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/data/classes/analytics/indicator/cognitive_depth.php b/mod/data/classes/analytics/indicator/cognitive_depth.php
index 3380ce0..8941bb0 100644
--- a/mod/data/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/data/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/data/classes/analytics/indicator/social_breadth.php b/mod/data/classes/analytics/indicator/social_breadth.php
index 75d0718..ac1e2c9 100644
--- a/mod/data/classes/analytics/indicator/social_breadth.php
+++ b/mod/data/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/feedback/classes/analytics/indicator/cognitive_depth.php b/mod/feedback/classes/analytics/indicator/cognitive_depth.php
index 87a7d0c..68833b6 100644
--- a/mod/feedback/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/feedback/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/feedback/classes/analytics/indicator/social_breadth.php b/mod/feedback/classes/analytics/indicator/social_breadth.php
index b498a21..2d89446 100644
--- a/mod/feedback/classes/analytics/indicator/social_breadth.php
+++ b/mod/feedback/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/folder/classes/analytics/indicator/cognitive_depth.php b/mod/folder/classes/analytics/indicator/cognitive_depth.php
index bd781b7..19e578b 100644
--- a/mod/folder/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/folder/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/folder/classes/analytics/indicator/social_breadth.php b/mod/folder/classes/analytics/indicator/social_breadth.php
index 2ea1a05..d19941b 100644
--- a/mod/folder/classes/analytics/indicator/social_breadth.php
+++ b/mod/folder/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/forum/classes/analytics/indicator/cognitive_depth.php b/mod/forum/classes/analytics/indicator/cognitive_depth.php
index 026f4a7..f8ff05d 100644
--- a/mod/forum/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/forum/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/forum/classes/analytics/indicator/social_breadth.php b/mod/forum/classes/analytics/indicator/social_breadth.php
index 0741af8..7e6dc26 100644
--- a/mod/forum/classes/analytics/indicator/social_breadth.php
+++ b/mod/forum/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/glossary/classes/analytics/indicator/cognitive_depth.php b/mod/glossary/classes/analytics/indicator/cognitive_depth.php
index 8aa13a2..ba9027d 100644
--- a/mod/glossary/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/glossary/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/glossary/classes/analytics/indicator/social_breadth.php b/mod/glossary/classes/analytics/indicator/social_breadth.php
index 3c6c23d..2aca93d 100644
--- a/mod/glossary/classes/analytics/indicator/social_breadth.php
+++ b/mod/glossary/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/imscp/classes/analytics/indicator/cognitive_depth.php b/mod/imscp/classes/analytics/indicator/cognitive_depth.php
index e9e169a..cd6bc8f 100644
--- a/mod/imscp/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/imscp/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/imscp/classes/analytics/indicator/social_breadth.php b/mod/imscp/classes/analytics/indicator/social_breadth.php
index 69b8680..22af33f 100644
--- a/mod/imscp/classes/analytics/indicator/social_breadth.php
+++ b/mod/imscp/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/label/classes/analytics/indicator/cognitive_depth.php b/mod/label/classes/analytics/indicator/cognitive_depth.php
index 40a0d1c..68582c7 100644
--- a/mod/label/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/label/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/label/classes/analytics/indicator/social_breadth.php b/mod/label/classes/analytics/indicator/social_breadth.php
index e1af591..ae1ea34 100644
--- a/mod/label/classes/analytics/indicator/social_breadth.php
+++ b/mod/label/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/lesson/classes/analytics/indicator/cognitive_depth.php b/mod/lesson/classes/analytics/indicator/cognitive_depth.php
index b4ecccc..dc2a202 100644
--- a/mod/lesson/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/lesson/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/lesson/classes/analytics/indicator/social_breadth.php b/mod/lesson/classes/analytics/indicator/social_breadth.php
index 62b3f4e..adfe598 100644
--- a/mod/lesson/classes/analytics/indicator/social_breadth.php
+++ b/mod/lesson/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/lti/classes/analytics/indicator/cognitive_depth.php b/mod/lti/classes/analytics/indicator/cognitive_depth.php
index 247d0d8..0a7e8f4 100644
--- a/mod/lti/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/lti/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/lti/classes/analytics/indicator/social_breadth.php b/mod/lti/classes/analytics/indicator/social_breadth.php
index dfd66c3..08759b6 100644
--- a/mod/lti/classes/analytics/indicator/social_breadth.php
+++ b/mod/lti/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/page/classes/analytics/indicator/cognitive_depth.php b/mod/page/classes/analytics/indicator/cognitive_depth.php
index ec79120..921597c 100644
--- a/mod/page/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/page/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/page/classes/analytics/indicator/social_breadth.php b/mod/page/classes/analytics/indicator/social_breadth.php
index 81c489d..0f9815f 100644
--- a/mod/page/classes/analytics/indicator/social_breadth.php
+++ b/mod/page/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/quiz/classes/analytics/indicator/cognitive_depth.php b/mod/quiz/classes/analytics/indicator/cognitive_depth.php
index e47ffdb..eed2622 100644
--- a/mod/quiz/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/quiz/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/quiz/classes/analytics/indicator/social_breadth.php b/mod/quiz/classes/analytics/indicator/social_breadth.php
index 1617c98..b4eb9881 100644
--- a/mod/quiz/classes/analytics/indicator/social_breadth.php
+++ b/mod/quiz/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/resource/classes/analytics/indicator/cognitive_depth.php b/mod/resource/classes/analytics/indicator/cognitive_depth.php
index 12e5bcc..e7a1386 100644
--- a/mod/resource/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/resource/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/resource/classes/analytics/indicator/social_breadth.php b/mod/resource/classes/analytics/indicator/social_breadth.php
index 4ebee9d..663c082 100644
--- a/mod/resource/classes/analytics/indicator/social_breadth.php
+++ b/mod/resource/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/scorm/classes/analytics/indicator/cognitive_depth.php b/mod/scorm/classes/analytics/indicator/cognitive_depth.php
index 82d43b5..b19bf18 100644
--- a/mod/scorm/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/scorm/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/scorm/classes/analytics/indicator/social_breadth.php b/mod/scorm/classes/analytics/indicator/social_breadth.php
index e4ce899..be4cfe2 100644
--- a/mod/scorm/classes/analytics/indicator/social_breadth.php
+++ b/mod/scorm/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/survey/classes/analytics/indicator/cognitive_depth.php b/mod/survey/classes/analytics/indicator/cognitive_depth.php
index 8122765..30ff8a0 100644
--- a/mod/survey/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/survey/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/survey/classes/analytics/indicator/social_breadth.php b/mod/survey/classes/analytics/indicator/social_breadth.php
index 7c771be..a59afee 100644
--- a/mod/survey/classes/analytics/indicator/social_breadth.php
+++ b/mod/survey/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/url/classes/analytics/indicator/cognitive_depth.php b/mod/url/classes/analytics/indicator/cognitive_depth.php
index 0710024..ab98665 100644
--- a/mod/url/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/url/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/url/classes/analytics/indicator/social_breadth.php b/mod/url/classes/analytics/indicator/social_breadth.php
index 1f46a38..74a8dcf 100644
--- a/mod/url/classes/analytics/indicator/social_breadth.php
+++ b/mod/url/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/wiki/classes/analytics/indicator/cognitive_depth.php b/mod/wiki/classes/analytics/indicator/cognitive_depth.php
index fd4a47a..7209a51 100644
--- a/mod/wiki/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/wiki/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/wiki/classes/analytics/indicator/social_breadth.php b/mod/wiki/classes/analytics/indicator/social_breadth.php
index e45fb9b..45bf171 100644
--- a/mod/wiki/classes/analytics/indicator/social_breadth.php
+++ b/mod/wiki/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 
diff --git a/mod/workshop/classes/analytics/indicator/cognitive_depth.php b/mod/workshop/classes/analytics/indicator/cognitive_depth.php
index e55d0a5..9b4e36d 100644
--- a/mod/workshop/classes/analytics/indicator/cognitive_depth.php
+++ b/mod/workshop/classes/analytics/indicator/cognitive_depth.php
@@ -49,7 +49,7 @@ class cognitive_depth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_COGNITIVE;
     }
 
diff --git a/mod/workshop/classes/analytics/indicator/social_breadth.php b/mod/workshop/classes/analytics/indicator/social_breadth.php
index 82fc63c..c1f4d58 100644
--- a/mod/workshop/classes/analytics/indicator/social_breadth.php
+++ b/mod/workshop/classes/analytics/indicator/social_breadth.php
@@ -49,7 +49,7 @@ class social_breadth extends activity_base {
      *
      * @return string
      */
-    protected function get_indicator_type() {
+    public function get_indicator_type() {
         return self::INDICATOR_SOCIAL;
     }
 